<!DOCTYPE HTML> 
<html lang="en"> 
<head>
<title>MP2 - aychen3</title>
<meta charset="utf-8"> 
</head>
	
<script id="blinnphongshader-vs" type="x-shader/x-vertex">
	attribute vec3 aVertexNormal;
	attribute vec3 aVertexPosition;
   
	uniform mat4 uMVMatrix;
	uniform mat4 uPMatrix;
	uniform mat3 uNMatrix;
	varying vec3 vNormal;
	varying vec3 vPosition;

	varying vec3 heightcolor;

	varying vec4 fogColor;
	varying float fogDensity;
	varying float fogFactor;
	varying float fogFragCoord;
	
	void main(void) {
	
		// Get the vertex position in eye coordinates
		vec4 vertexPositionEye4 = uMVMatrix * vec4(aVertexPosition, 1.0);
		vPosition = vertexPositionEye4.xyz / vertexPositionEye4.w;
		//Calaulate the normal
		vNormal = normalize(uNMatrix * aVertexNormal);
	   
		gl_Position = uPMatrix*uMVMatrix*vec4(aVertexPosition, 1.0);

		if (aVertexPosition[2] < 0.25) {
			heightcolor = vec3(0.1,0.25,0.75);
		}
		else if (aVertexPosition[2] < 0.50) {
			heightcolor = vec3(0.1,0.75,0.25);
		}
		else if (aVertexPosition[2] < 0.75) {
			heightcolor = vec3(0.5,0.1,0.1);
		}
		else {
			heightcolor = vec3(1.0,1.0,1.0);
		}

		fogColor = vec4(1.0,1.0,1.0,1.0);
		fogDensity = 0.3;

		//calculate fog factor
		const float LOG2 = 1.442695;
		fogFragCoord = length(vertexPositionEye4);
		fogFactor = exp2(-fogDensity * fogDensity * fogFragCoord * fogFragCoord * LOG2);
		fogFactor = clamp(fogFactor, 0.0, 1.0);

	}
</script>

<script id="blinnphongshader-fs" type="x-shader/x-fragment">
	precision mediump float;
	varying vec3 vNormal;
	varying vec3 vPosition;

	uniform vec3 uLightPosition;
	uniform vec3 uAmbientLightColor;
	uniform vec3 uDiffuseLightColor;
	uniform vec3 uSpecularLightColor;
	uniform vec3 uAmbientMaterialColor;
	uniform vec3 uDiffuseMaterialColor;
	uniform vec3 uSpecularMaterialColor;
	uniform float uShininess;

	varying vec3 heightcolor;

	varying vec4 fogColor;
	varying float fogFactor;

	void main(void) {
		vec4 vColor;
		// Calculate the vector (l) to the light source
		vec3 vectorToLightSource = normalize(uLightPosition - vPosition);
		
		// Calculate n dot l for diffuse lighting
		float diffuseLightWeightning = max(dot(vNormal, 
										vectorToLightSource), 0.0);
		
		// The camera in eye coordinates is located in the origin and is pointing
		// along the negative z-axis. Calculate viewVector (v) 
		// in eye coordinates as:
		// (0.0, 0.0, 0.0) - vertexPositionEye3
		vec3 viewVectorEye = -normalize(vPosition);
		
										   
		// Calculate the reflection vector (r) that is needed for specular light
		vec3 halfwayVector = normalize(vectorToLightSource+viewVectorEye);

		float ndoth = max(dot(halfwayVector, viewVectorEye), 0.0);
		
		float specularLightWeightning = pow(ndoth, uShininess);

		// Sum up all three reflection components and send to the fragment shader
		vColor = vec4(((uAmbientLightColor*uAmbientMaterialColor*heightcolor)
					+ (uDiffuseLightColor*uDiffuseMaterialColor*heightcolor) * diffuseLightWeightning
					+ (uSpecularLightColor*uSpecularMaterialColor*heightcolor) * specularLightWeightning),1.0);


		gl_FragColor = mix(fogColor, vColor, fogFactor);
	}
</script>

<script src="gl-matrix-min.js"></script> 
<script src="webgl-utils.js"></script>
<script src="simpleModeling.js"></script>   
<script src="terrainModeling.js"></script>  
<script src="mp2.js"></script>   
<body onload="startup();">
	<canvas id="myGLCanvas" width="1000" height="500"></canvas>
	<table>
		<tr>
			<th>Key</th>
			<th>Function</th> 
		</tr>
		<tr>
			<td>Left Arrow</td>
			<td>Make the plane roll to its left.</td>
		</tr>
		<tr>
			<td>Right Arrow</td>
			<td>Make the plane roll to its right.</td>
		</tr>
		<tr>
			<td>Up Arrow</td>
			<td>Cause the plane to pitch up.</td>
		</tr>
		<tr>
			<td>Down Arrow</td>
			<td>Cause the plane to pitch down.</td>
		</tr>
		<tr>
			<td>Plus Key (+) or Equal Sign Key (=)</td>
			<td>Increase the airplane's speed.</td>
		</tr>
		<tr>
			<td>Minus Key (-)</td>
			<td>Decrease the airplane's speed.</td>
		</tr>
		<tr>
			<td>r</td>
			<td>Restart the flight.</td>
		</tr>
</table>
</body>

</html>
